Add matching and parsing for fetch-side refspec rules
[git/dscho.git] / git-am.sh
blob6809aa07f60165855ebc0192750e85569f9685ff
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--keep] [--utf8 | --no-utf8]
6 [--3way] [--interactive] [--binary]
7 [--whitespace=<option>] [-C<n>] [-p<n>]
8 <mbox>|<Maildir>...
9 or, when resuming [--skip | --resolved]'
10 . git-sh-setup
11 set_reflog_action am
12 require_work_tree
14 git var GIT_COMMITTER_IDENT >/dev/null || exit
16 stop_here () {
17 echo "$1" >"$dotest/next"
18 exit 1
21 stop_here_user_resolve () {
22 if [ -n "$resolvemsg" ]; then
23 printf '%s\n' "$resolvemsg"
24 stop_here $1
26 cmdline=$(basename $0)
27 if test '' != "$interactive"
28 then
29 cmdline="$cmdline -i"
31 if test '' != "$threeway"
32 then
33 cmdline="$cmdline -3"
35 if test '.dotest' != "$dotest"
36 then
37 cmdline="$cmdline -d=$dotest"
39 echo "When you have resolved this problem run \"$cmdline --resolved\"."
40 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
42 stop_here $1
45 go_next () {
46 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
47 "$dotest/patch" "$dotest/info"
48 echo "$next" >"$dotest/next"
49 this=$next
52 cannot_fallback () {
53 echo "$1"
54 echo "Cannot fall back to three-way merge."
55 exit 1
58 fall_back_3way () {
59 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
61 rm -fr "$dotest"/patch-merge-*
62 mkdir "$dotest/patch-merge-tmp-dir"
64 # First see if the patch records the index info that we can use.
65 git apply -z --index-info "$dotest/patch" \
66 >"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68 git update-index -z --index-info <"$dotest/patch-merge-index-info" &&
69 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
70 git write-tree >"$dotest/patch-merge-base+" ||
71 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
73 echo Using index info to reconstruct a base tree...
74 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
75 git apply $binary --cached <"$dotest/patch"
76 then
77 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
78 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
79 else
80 cannot_fallback "Did you hand edit your patch?
81 It does not apply to blobs recorded in its index."
84 test -f "$dotest/patch-merge-index" &&
85 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
86 orig_tree=$(cat "$dotest/patch-merge-base") &&
87 rm -fr "$dotest"/patch-merge-* || exit 1
89 echo Falling back to patching base and 3-way merge...
91 # This is not so wrong. Depending on which base we picked,
92 # orig_tree may be wildly different from ours, but his_tree
93 # has the same set of wildly different changes in parts the
94 # patch did not touch, so recursive ends up canceling them,
95 # saying that we reverted all those changes.
97 eval GITHEAD_$his_tree='"$SUBJECT"'
98 export GITHEAD_$his_tree
99 git-merge-recursive $orig_tree -- HEAD $his_tree || {
100 git rerere
101 echo Failed to merge in the changes.
102 exit 1
104 unset GITHEAD_$his_tree
107 prec=4
108 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
109 resolvemsg= resume=
110 git_apply_opt=
112 while case "$#" in 0) break;; esac
114 case "$1" in
115 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
116 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
117 -d|--d|--do|--dot|--dote|--dotes|--dotest)
118 case "$#" in 1) usage ;; esac; shift
119 dotest="$1"; shift;;
121 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
122 --interacti|--interactiv|--interactive)
123 interactive=t; shift ;;
125 -b|--b|--bi|--bin|--bina|--binar|--binary)
126 binary=t; shift ;;
128 -3|--3|--3w|--3wa|--3way)
129 threeway=t; shift ;;
130 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
131 sign=t; shift ;;
132 -u|--u|--ut|--utf|--utf8)
133 utf8=t; shift ;; # this is now default
134 --no-u|--no-ut|--no-utf|--no-utf8)
135 utf8=; shift ;;
136 -k|--k|--ke|--kee|--keep)
137 keep=t; shift ;;
139 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
140 resolved=t; shift ;;
142 --sk|--ski|--skip)
143 skip=t; shift ;;
145 --whitespace=*|-C*|-p*)
146 git_apply_opt="$git_apply_opt $1"; shift ;;
148 --resolvemsg=*)
149 resolvemsg=${1#--resolvemsg=}; shift ;;
152 shift; break ;;
154 usage ;;
156 break ;;
157 esac
158 done
160 # If the dotest directory exists, but we have finished applying all the
161 # patches in them, clear it out.
162 if test -d "$dotest" &&
163 last=$(cat "$dotest/last") &&
164 next=$(cat "$dotest/next") &&
165 test $# != 0 &&
166 test "$next" -gt "$last"
167 then
168 rm -fr "$dotest"
171 if test -d "$dotest"
172 then
173 case "$#,$skip$resolved" in
174 0,*t*)
175 # Explicit resume command and we do not have file, so
176 # we are happy.
177 : ;;
179 # No file input but without resume parameters; catch
180 # user error to feed us a patch from standard input
181 # when there is already .dotest. This is somewhat
182 # unreliable -- stdin could be /dev/null for example
183 # and the caller did not intend to feed us a patch but
184 # wanted to continue unattended.
185 tty -s
188 false
190 esac ||
191 die "previous dotest directory $dotest still exists but mbox given."
192 resume=yes
193 else
194 # Make sure we are not given --skip nor --resolved
195 test ",$skip,$resolved," = ,,, ||
196 die "Resolve operation not in progress, we are not resuming."
198 # Start afresh.
199 mkdir -p "$dotest" || exit
201 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
202 rm -fr "$dotest"
203 exit 1
206 # -b, -s, -u, -k and --whitespace flags are kept for the
207 # resuming session after a patch failure.
208 # -3 and -i can and must be given when resuming.
209 echo "$binary" >"$dotest/binary"
210 echo " $ws" >"$dotest/whitespace"
211 echo "$sign" >"$dotest/sign"
212 echo "$utf8" >"$dotest/utf8"
213 echo "$keep" >"$dotest/keep"
214 echo 1 >"$dotest/next"
217 case "$resolved" in
219 files=$(git diff-index --cached --name-only HEAD) || exit
220 if [ "$files" ]; then
221 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
222 exit 1
224 esac
226 if test "$(cat "$dotest/binary")" = t
227 then
228 binary=--allow-binary-replacement
230 if test "$(cat "$dotest/utf8")" = t
231 then
232 utf8=-u
233 else
234 utf8=-n
236 if test "$(cat "$dotest/keep")" = t
237 then
238 keep=-k
240 ws=`cat "$dotest/whitespace"`
241 if test "$(cat "$dotest/sign")" = t
242 then
243 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
244 s/>.*/>/
245 s/^/Signed-off-by: /'
247 else
248 SIGNOFF=
251 last=`cat "$dotest/last"`
252 this=`cat "$dotest/next"`
253 if test "$skip" = t
254 then
255 git rerere clear
256 this=`expr "$this" + 1`
257 resume=
260 if test "$this" -gt "$last"
261 then
262 echo Nothing to do.
263 rm -fr "$dotest"
264 exit
267 while test "$this" -le "$last"
269 msgnum=`printf "%0${prec}d" $this`
270 next=`expr "$this" + 1`
271 test -f "$dotest/$msgnum" || {
272 resume=
273 go_next
274 continue
277 # If we are not resuming, parse and extract the patch information
278 # into separate files:
279 # - info records the authorship and title
280 # - msg is the rest of commit log message
281 # - patch is the patch body.
283 # When we are resuming, these files are either already prepared
284 # by the user, or the user can tell us to do so by --resolved flag.
285 case "$resume" in
287 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
288 <"$dotest/$msgnum" >"$dotest/info" ||
289 stop_here $this
291 # skip pine's internal folder data
292 grep '^Author: Mail System Internal Data$' \
293 <"$dotest"/info >/dev/null &&
294 go_next && continue
296 test -s $dotest/patch || {
297 echo "Patch is empty. Was it split wrong?"
298 stop_here $this
300 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
302 esac
304 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
305 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
306 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
308 if test -z "$GIT_AUTHOR_EMAIL"
309 then
310 echo "Patch does not have a valid e-mail address."
311 stop_here $this
314 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
316 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
317 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
319 case "$resume" in
321 if test '' != "$SIGNOFF"
322 then
323 LAST_SIGNED_OFF_BY=`
324 sed -ne '/^Signed-off-by: /p' \
325 "$dotest/msg-clean" |
326 tail -n 1
328 ADD_SIGNOFF=`
329 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
330 test '' = "$LAST_SIGNED_OFF_BY" && echo
331 echo "$SIGNOFF"
333 else
334 ADD_SIGNOFF=
337 printf '%s\n' "$SUBJECT"
338 if test -s "$dotest/msg-clean"
339 then
340 echo
341 cat "$dotest/msg-clean"
343 if test '' != "$ADD_SIGNOFF"
344 then
345 echo "$ADD_SIGNOFF"
347 } >"$dotest/final-commit"
350 case "$resolved$interactive" in
352 # This is used only for interactive view option.
353 git diff-index -p --cached HEAD >"$dotest/patch"
355 esac
356 esac
358 resume=
359 if test "$interactive" = t
360 then
361 test -t 0 ||
362 die "cannot be interactive without stdin connected to a terminal."
363 action=again
364 while test "$action" = again
366 echo "Commit Body is:"
367 echo "--------------------------"
368 cat "$dotest/final-commit"
369 echo "--------------------------"
370 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
371 read reply
372 case "$reply" in
373 [yY]*) action=yes ;;
374 [aA]*) action=yes interactive= ;;
375 [nN]*) action=skip ;;
376 [eE]*) git_editor "$dotest/final-commit"
377 action=again ;;
378 [vV]*) action=again
379 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
380 *) action=again ;;
381 esac
382 done
383 else
384 action=yes
387 if test $action = skip
388 then
389 go_next
390 continue
393 if test -x "$GIT_DIR"/hooks/applypatch-msg
394 then
395 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
396 stop_here $this
399 echo
400 printf 'Applying %s\n' "$SUBJECT"
401 echo
403 case "$resolved" in
405 git apply $git_apply_opt $binary --index "$dotest/patch"
406 apply_status=$?
409 # Resolved means the user did all the hard work, and
410 # we do not have to do any patch application. Just
411 # trust what the user has in the index file and the
412 # working tree.
413 resolved=
414 git diff-index --quiet --cached HEAD && {
415 echo "No changes - did you forget to use 'git add'?"
416 stop_here_user_resolve $this
418 unmerged=$(git ls-files -u)
419 if test -n "$unmerged"
420 then
421 echo "You still have unmerged paths in your index"
422 echo "did you forget to use 'git add'?"
423 stop_here_user_resolve $this
425 apply_status=0
426 git rerere
428 esac
430 if test $apply_status = 1 && test "$threeway" = t
431 then
432 if (fall_back_3way)
433 then
434 # Applying the patch to an earlier tree and merging the
435 # result may have produced the same tree as ours.
436 git diff-index --quiet --cached HEAD && {
437 echo No changes -- Patch already applied.
438 go_next
439 continue
441 # clear apply_status -- we have successfully merged.
442 apply_status=0
445 if test $apply_status != 0
446 then
447 echo Patch failed at $msgnum.
448 stop_here_user_resolve $this
451 if test -x "$GIT_DIR"/hooks/pre-applypatch
452 then
453 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
456 tree=$(git write-tree) &&
457 echo Wrote tree $tree &&
458 parent=$(git rev-parse --verify HEAD) &&
459 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
460 echo Committed: $commit &&
461 git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
462 stop_here $this
464 if test -x "$GIT_DIR"/hooks/post-applypatch
465 then
466 "$GIT_DIR"/hooks/post-applypatch
469 go_next
470 done
472 rm -fr "$dotest"